import playground
import random
import math

class Atom(object):
    
    def __init__(self, pos, velocity, rad, col):
        self.pos = pos
        self.velocity = velocity
        self.rad = rad
        self.col = col

    def apply_speed(self, size_x, size_y):
        pos_x, pos_y = self.pos
        vel_x, vel_y = self.velocity
        pos_x += vel_x
        pos_y += vel_y
        
        self.pos = (pos_x, pos_y)
        if pos_x + self.rad > size_x:
            self.velocity = (-vel_x, vel_y)
            pos_x = size_x - self.rad
        if pos_x < self.rad:
            self.velocity = (-vel_x, vel_y)
            pos_x = self.rad

        if pos_y + self.rad > size_y:
            self.velocity = (vel_x, -vel_y)
            pos_y = size_y - self.rad
        if pos_y < self.rad:
            self.velocity = (vel_x, -vel_y)
            pos_y = self.rad

        self.pos = (pos_x, pos_y)
    
    def get_quadruple(self):
        pos_x, pos_y = self.pos
        return (pos_x, pos_y, self.rad, self.col)

    
class RandomWorld(object):

    def __init__(self):        
        self.atoms = []

    def random_color(self):
        """
        Generuje nahodnou barvu atomu.
        Vystup: string
        Priklad: '#FFA3D6'
        Hint: Pro generovani hexa cisel vyuzijte funkci hex
        """

    def random_atom(self, size_x, size_y):
        """
        Varaci instanci tridy Atom nebo FallDownAtom. Rozhodnuti, zda je to ten
        ci onen atom je dano nahodne vygenerovanym cislem v rozsahu 0.0 - 1.0.
        Pravdepodobnost nagenerovani obou druhu atomu je stejna.
        Nahodne se take generuje poloha, vektor rychlosti a barva.
        """

    def random_atoms(self, size_x, size_y, amount):
        """
        Promennou self.atoms naplni atomy zadanym poctem atomu v dimenzich sveta.
        """

    def get_list_of_atoms(self):
        """
        Vraci list atomu v reprezentaci, ktera je pouzitelna pro metodu 'tick'.
        """

    def tick(self, size_x, size_y):
        return [(100, 50, 15, '#FF0000')]

world = RandomWorld()

size_x, size_y = 400, 300
world.random_atoms(size_x, size_y, 10)

playground.run((size_x, size_y), world)
